Attribute VB_Name = "ModDialogFolders"
Option Explicit

Dim ec As New ModDlgFolderClass

Public Sub Init()
    Call ec.disconnect
    Call ec.connect
        
    'Dim vBrowseResult As Variant
    'vBrowseResult = BrowseForFolder(sADPP)
    
    'If Not vBrowseResult = False Then
    '    ec.sPath = vBrowseResult
    'End If
    
    ec.sPath = GetDocPath()
    
    If ec.sPath = "" Then  'Aktives Dokument ist noch nicht gespeichert, nehmen wir halt den Projektpfad
        Dim oDPM As DesignProjectManager
        Set oDPM = ThisApplication.DesignProjectManager
        Dim oADP As DesignProject
        Set oADP = oDPM.ActiveDesignProject
        ec.sPath = oADP.WorkspacePath
    End If
    
End Sub

Public Function GetDocPath() As String

    Dim oApp As Inventor.Application
    Set oApp = ThisApplication

    Dim oDoc As Document
    Set oDoc = oApp.ActiveDocument
    
    Dim oFS As FileSystemObject
    Set oFS = CreateObject("Scripting.FileSystemObject")
    
    On Error Resume Next
    GetDocPath = oFS.GetParentFolderName(oDoc.FullFileName)
    
    If Err Then GetDocPath = ""
    
End Function


Public Sub ModOpenDialog()

    Dim oApp As Inventor.Application
    Set oApp = ThisApplication
    
    Dim sNewName As String
    
    Dim oFileDialog As Inventor.FileDialog
    Call oApp.CreateFileDialog(oFileDialog)

    oFileDialog.InitialDirectory = ec.sPath
    oFileDialog.OptionsEnabled = True
    oFileDialog.FilterIndex = 0
    oFileDialog.CancelError = True
    oFileDialog.Filter = "Autodesk Inventor-Dateien (*.iam;*.ipt;*.ipn;*.dwg;*.idw;*.ide)|*.iam;*.ipt;*.ipn;*.dwg;*.idw;*.ide|" & _
                    "Autodesk Inventor-Baugruppen (*.iam)|*.iam|" & _
                    "Autodesk Inventor-Bauteile (*.ipt)|*.ipt|" & _
                    "Autodesk Inventor-Prsentationen (*.ipn)|*.ipn|" & _
                    "Autodesk Inventor-Zeichnungen (*.dwg; *.idw)|*.dwg;*.idw|" & _
                    "Autodesk Inventor-iFeatures (*.ide)|*.ide|Alias-Dateien (*.wire)|*.wire|AutoCAD DWG-Dateien (*.dwg)|*.dwg|" & _
                    "CATIA V4-Dateien (*.model;*.session;*.exp;*.dlv3)|*.model;*.session;*.exp;*.dlv3|CATIA V5-Dateien (*.CATPart;*.CATProduct;*.cgr)|*.catpart;*.catproduct;*.cgr|" & _
                    "DWF-Markierungsdateien (*.dwf;*.dwfx)|*.dwf;*.dwfx|DXF-Dateien (*.dxf)|*.dxf|Fusion-Dateien (*.fusiondesign)|**.fusiondesign|" & _
                    "IDF-Board-Dateien (*.brd;*.emn;*.bdf;*.idb)|*.brd;*.emn;*.bdf;*.idb|IGES-Dateien (*.igs;*.ige;*.iges)|*.igs;*.ige;*.iges|" & _
                    "JT-Dateien (*.jt)|*.jt|NX-Dateien (*.prt)|*.prt|OBJ-Dateien (*.obj)|*.obj|Parasolid-Binrdateien (*.x_b)|*.x_b|Parasolid-Textdateien (*.x_t)|*.x_t|" & _
                    "Pro/ENGINEER Granite-Dateien (*.g)|*.g|Pro/ENGINEER Neutral-Dateien (*.neu*)|*.neu*|Pro/ENGINEER- und Creo Parametric-Dateien (*.prt*;*.asm*)|*.prt*;*.asm*|" & _
                    "Revit-Projektdateien (*.rvt)|*.rvt|Rhino-Dateien (*.3dm)|*.3dm|SAT-Dateien (*.sat)|*.sat|SMT-Dateien (*.smt)|*.smt|STEP-Dateien (*.stp;*.ste;*.step;*.stpz)|*.stp;*.ste;*.step;*.stpz|" & _
                    "STL-Dateien (*.stl;*.stla;*.stlb)|*.stl;*.stla;*.stlb|Solid Edge-Dateien (*.par;*.psm;*.asm)|**.par;*.psm;*.asm|SolidWorks-Dateien (*.prt;*.sldprt;*.asm;*.sldasm)|*.prt;*.sldprt;*.asm;*.sldasm|" & _
                    "Alle Dateien (*.*)|*.*"
                    
    oFileDialog.DialogTitle = "ModOpen" ' "ffnen"
    
    On Error Resume Next
    oFileDialog.ShowOpen

    If Err Then ' Err is set when User presses Cancel
        Exit Sub
    ElseIf oFileDialog.FileName <> "" Then
        sNewName = oFileDialog.FileName
        On Error GoTo 0
    End If

    Call oApp.Documents.Open(sNewName)
    
End Sub
